var livescriptAstTransform, x$, Plugin, hasAwaitIn;
livescriptAstTransform = require('livescript-ast-transform');
x$ = Plugin = Object.create(livescriptAstTransform);
module.exports = x$;
x$.name = 'transform-top-level-await';
x$.overrideOptions = true;
x$.enable = function(){
  var Block, x$, originalCompileRoot, Self;
  Block = this.livescript.ast.Block;
  x$ = originalCompileRoot = Block.prototype.compileRoot;
  this.originalCompileRoot = x$;
  Self = this;
  Block.prototype.compileRoot = function(options){
    var isAsyncBlock, x$, result;
    isAsyncBlock = hasAwaitIn(this);
    if (isAsyncBlock && Self.overrideOptions) {
      options.bare = false;
    }
    if (isAsyncBlock && options.bare === true) {
      throw Error("Top level code should be wrap in async function but compile option 'bare' is preventing it.");
    }
    x$ = result = originalCompileRoot.call(this, options);
    if (isAsyncBlock) {
      x$.children[0] = '(async function(){\n';
    }
    return x$;
  };
};
x$.disable = function(){
  Block.prototype.compileRoot = this.originalCompileRoot;
};
hasAwaitIn = function(block){
  var result, isAwait;
  result = null;
  isAwait = function(child, parent, name, index){
    if (child.op === 'await') {
      result = true;
    }
    return result;
  };
  block.traverseChildren(isAwait, false);
  return result != null ? result : false;
};
//# sourceMappingURL=plugin.js.map
